// -*- mode: c++; indent-tabs-mode: nil; -*-
//
//
// CodeAxe : phylogenetic analysis and simulation tools
//
//   http://www.phrap.org
//
//
// Copyright 2007 Christopher T Saunders (ctsa@u.washington.edu)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of the
// License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
// 02110-1301, USA.
//
//

// $Id: cat_post_prob.h 741 2007-08-14 02:39:19Z ctsa $

/// \file

#ifndef CAT_POST_PROB
#define CAT_POST_PROB


#include "bi_tree_type.h"
#include "rate_gtor_options.h"
#include "site_data_fastlup.h"
#include "subs_ml_types.h"

#include <vector>


void
cat_post_prob_report(const RATE_GTOR_MODEL::index_t rgm,
                     const bi_tree_sml_type& tree,
                     const int n_site_cats,
                     const site_data_fastlup& full_sdf,
                     const prob_t* cat_site_prob,            // n_site_cats*full_sdf.len
                     const std::vector<prob_t>& site_cat_prior_pdistro);

#endif
