// -*- mode: c++; indent-tabs-mode: nil; -*-
//
//
// CodeAxe : phylogenetic analysis and simulation tools
//
//   http://www.phrap.org
//
//
// Copyright 2007 Christopher T Saunders (ctsa@u.washington.edu)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of the
// License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
// 02110-1301, USA.
//
//

// $Id: count_data_code.h 741 2007-08-14 02:39:19Z ctsa $

/// \file

#ifndef __COUNT_DATA_CODE_H
#define __COUNT_DATA_CODE_H

#include <cassert>

#include <limits>


/// \brief stores all info (cat no) associated with input
/// count information at each site and sorts appropriately for c++
/// stdlib use
///
struct count_data_code {

  typedef unsigned char cat_type;

  count_data_code(unsigned _cn = 0)
    : cat_no(_cn) {
    assert(std::numeric_limits<cat_type>::max()>=_cn);
  }

  bool
  operator==(const count_data_code& right) const {
    if(! (cat_no == right.cat_no)) return false;
    return true;
  }

  bool
  operator<(const count_data_code& right) const {
    if(! (cat_no == right.cat_no)) return cat_no < right.cat_no;
    return false;
  }

  cat_type cat_no;
};


#endif
