// -*- mode: c++; indent-tabs-mode: nil; -*-
//
//
// CodeAxe : phylogenetic analysis and simulation tools
//
//   http://www.phrap.org
//
//
// Copyright 2007 Christopher T Saunders (ctsa@u.washington.edu)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of the
// License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
// 02110-1301, USA.
//
//

// $Id: subs_ml_model_comex.cc 741 2007-08-14 02:39:19Z ctsa $

/// \file

#include "subs_ml_model.h"
#include "subs_ml_model_comex.h"
#include "subs_ml_model_root_from_obs.h"


const cat_manager&
subs_ml_model_comex::
get_cat_manager() const { return _smlm.get_cat_manager(); }


RATE_GTOR_MODEL::index_t
subs_ml_model_comex::
rate_gtor_model() const { return _smlm.rate_gtor_model(); }


unsigned
subs_ml_model_comex::
state_size() const { return _smlm.state_size(); }


const prob_t*
rate_gtor_sml_share::
obs_state_distro() const { return _smlm.obs_state_distro(); }

const prob_t*
rate_gtor_sml_share::
obs_state_distro_assigned_cat(const unsigned c) const { return _smlm.obs_state_distro_assigned_cat(c); }

void
root_gtor_sml_share::
get_obs_state_time_avg_root(prob_t* root_down_prob,
                            const bool is_assigned_cat,
                            const unsigned assigned_cat_no) const {
  subs_ml_model_obs_state_time_avg_root(_smlm,root_down_prob,is_assigned_cat,assigned_cat_no);
}

bool
root_gtor_sml_share::
get_root_node_prob(prob_t* root_node_prob,
                   const bool is_leastsq,
                   const bool is_assigned_cat,
                   const unsigned assigned_cat_no) const {
  return subs_ml_model_root_node_prob(_smlm,root_node_prob,is_leastsq,
                                      is_assigned_cat,assigned_cat_no);
}

#ifdef BRANCH_SPECIFIC_OBS
unsigned
root_gtor_sml_share::
branch_size() const {
  return _smlm.tree().n_branches();
}

bool
root_gtor_sml_share::
get_root_node_prob_nspround(prob_t* root_node_prob,
                            const bool is_leastsq,
                            const bool is_assigned_cat,
                            const unsigned assigned_cat_no,
                            prob_t** node_state_prob) const {

  return subs_ml_model_root_node_prob_nspround(_smlm,root_node_prob,is_leastsq,
                                               is_assigned_cat,assigned_cat_no,
                                               node_state_prob);
}
#endif
