// -*- mode: c++; indent-tabs-mode: nil; -*-
//
//
// CodeAxe : phylogenetic analysis and simulation tools
//
//   http://www.phrap.org
//
//
// Copyright 2007 Christopher T Saunders (ctsa@u.washington.edu)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of the
// License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
// 02110-1301, USA.
//
//

// $Id: subs_ml_model_util.h 741 2007-08-14 02:39:19Z ctsa $

/// \file

#ifndef __SUBS_ML_MODEL_UTIL_H
#define __SUBS_ML_MODEL_UTIL_H


#include "site_data.h"
#include "subs_ml_model.h"

#include <vector>


/// \brief trained parameters initialized from data -- should be
/// called for new models only
///
/// 1) set the root distro to that of the present day data
/// 2) set assigned cat priors
/// 3) match assigned cat type to data cats
///
void
init_subs_ml_model_trained_data_dependencies(subs_ml_model& mdl,
                                             const site_data& sd,
                                             const std::vector<bool>& is_assigned_cats);


/// \brief untrained parameters dependent on data -- should be called
/// to initialize any model
///
/// 1) set the background distribution to that of the present day data
///
void
init_subs_ml_model_untrained_data_dependencies(subs_ml_model& mdl,
                                               const site_data& sd);


void
norm_model(subs_ml_model& mdl);

#endif
